Module | FFI
In: | lib/ffi/autopointer.rb lib/ffi/enum.rb lib/ffi/errno.rb lib/ffi/ffi.rb lib/ffi/io.rb lib/ffi/library.rb lib/ffi/managedstruct.rb lib/ffi/memorypointer.rb lib/ffi/platform.rb lib/ffi/pointer.rb lib/ffi/struct.rb lib/ffi/tools/const_generator.rb lib/ffi/tools/generator.rb lib/ffi/tools/struct_generator.rb lib/ffi/tools/types_generator.rb lib/ffi/types.rb lib/ffi/union.rb lib/ffi/variadic.rb

Copyright (C) 2008, 2009 Wayne Meissner Copyright (C) 2009 Luc Heinrich

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of the Evan Phoenix nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

### Methods

add_typedef create_invoker errno errno= find_type map_library_name size_to_type type_size

### Classes and Modules

Module FFI::IO
Module FFI::Library
Module FFI::Platform
Class FFI::AutoPointer
Class FFI::ConstGenerator
Class FFI::Enum
Class FFI::Enums
Class FFI::Generator
Class FFI::ManagedStruct
Class FFI::MemoryPointer
Class FFI::NativeError
Class FFI::NotFoundError
Class FFI::PlatformError
Class FFI::Pointer
Class FFI::SignatureError
Class FFI::Struct
Class FFI::StructGenerator
Class FFI::StructLayout
Class FFI::TypesGenerator
Class FFI::Union
Class FFI::VariadicInvoker

### Constants

CURRENT_PROCESS | = | USE_THIS_PROCESS_AS_LIBRARY = Object.new
ARCH | = | case CPU.downcase
TypeSizes | = | { 1 => :char, 2 => :short, 4 => :int, 8 => :long_long, }

### Public Class methods

add_typedef(current, add)

TypeDefs = Hash.new

create_invoker(lib, name, args, ret_type, options = { :convention => :default })
errno()
errno=(error)
find_type(name, type_map = nil)
map_library_name(lib)
size_to_type(size)
type_size(type)

[Validate]